// ConodGra.Prg

#Include "InKey.Ch"
#Include "Set.Ch"
#Include "Box.Ch"
#Include "SetCurs.Ch"
#Include "Control.Ch"

#include "dcdialog.ch"
#include "Appevent.ch"
#include "DCMSG.CH"
#include "font.ch"
#Include "xbp.Ch"
#include "gra.ch"
#include "Alertbox.ch"

MEMVAR mcSistema, mcColorCampo, nCaja, cAplNcf, mnLineaAvanzar, cPreLet, cClaLet
MemVar aColores, dFecha, cUsuario, cValMon, cAplCnt, dFecControl, cPreFac, mcImprNomVen

STATIC oTBar, NumLet, Opc, lVolver, cForma, lEditar

STATIC Opcr, rLinea, nContador, Opcc, aDbf, nPag, nValExe
STATIC nRow, cTipoItebis, aFactura, cFactura, cFacPre
STATIC nCanLin1, nCanLin2

STATIC J, cUsuari, lProcesa, nDiaTra, dFecFac, lDevolver

STATIC cImpres, cReimpr, OpcA, nArea, nValPie, cArtMad

STATIC nNumDoc, dFecDoc, cCodCli, cCodVen, nSubTot, nPorItb, nValItb, nPorDes
STATIC nTotNet, nTotPag, nTipItb, cComent, cEstado, cNomVen, nPorTar, cAplPor
STATIC cNomCli, cDirCli, cCiuCli, cTelCli, nDeuCli, nAboCli, nLimCre, cRepInv
STATIC nCantid, cDesArt, nDescue, nValDes, nEfecti, nFlete,  nCosto,  dFacFec
STATIC nValTar, nTarjet, nCheque, nNumNcr, cFacTip, nCantVe, dFecCie, cCodArtP
STATIC cCodArt, cItebis, cDesCue, nItebiA, nDescuA, cTelFax, nCanEnt, nNumFac
STATIC cRepUn1, cActInv, cCliPrec, cMoneda, cNcf, nNumNcf,   nFacPre, nUltimo
STATIC cRefere, nPreVen, nPrecio, nCanPen, nTotCono

STATIC nRegistro, aArreglo, cCajaFactura, lPrimeraPantalla, a

STATIC cOrdFac, cNombreArchivoTemporal, lPrimerCampo, cNombreOrden1

FIELD FacNum,   FacFec,   FacCli,  FacTot,  FacItb, FacDes,  CanEnt
FIELD FacNet,   FacPag,   FacObs,  Estado,  VenNom, Numero,  Aplicai
FIELD FacRep,   FacTip,   FacCan,  FacPre,  TotalE, FacFle,  RepPar
FIELD DesCue,   ValItb,   ArtInv,  RepDes,  RepCan, CliEmp,  NumNcf
FIELD CliCal,   CliEns,   CliTel,  CliFax,  CliCiu, Itebis,  ArtMad
FIELD CliDeuda, CliAbono, Letrero, Usuario, DeudaU, AbonoU,  CodPar
FIELD CodVen,   FacFac,   FacNoc,  PorDes,  PorItb, ValPie,  CantEnt
FIELD TipoItb,  EstNcr,   CantDv,  EstArt,  Cantid, FacSald, Ncf
FIELD FacCli2,  NumFac,   NumNcr,  Condic,  FecCie, CantDe,  Moneda
FIELD FacUni,   ActInv,   FacEmp,  FaEmp,   FacVnt, FaVnt,   FaNum
FIELD FaCli,    FacInv,   Refere,  FacCos,  CanPen, Linea,   CanLin1
FIELD CanLin2

PROCEDURE ConodGra()
   LOCAL oVentanaDatos
   
   LOCAL cAlias := "TEMPORAL"
   
   LOCAL aPres := ;
      { { XBP_PP_COL_HA_FGCLR, GRA_CLR_WHITE },  ;
        { XBP_PP_COL_HA_BGCLR, GRA_CLR_DARKGRAY }, ;
        { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
        { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE } }
   
   PRIVATE GetList := {}
   PRIVATE oBrowse
   PRIVATE alfabeto   := " .,-QWERTYUIOPASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm1234567890"  
   
   aDbf := {}     
      
   DBUSEAREA(.T.,,"CONOH",,.T.,.F.)
   If ErrorArc()
      RETURN
   Else 
      DBSETINDEX("CONOHNUM")
      DBSETINDEX("CONOHFEC")
      DBSETINDEX("CONOHCLI")
      DBSETINDEX("CONOHEMP")
      DBSETINDEX("CONOHCLF")
      DBSETINDEX("CONOHVEN")
      DBSETINDEX("CONOHFAC") 
      DBSETINDEX("CONOHNUD") 
   EndiF

  DBUSEAREA(.T.,,"CONOD",,.T.,.F.)
  If ErrorArc()
     RETURN
  Else 
     DBSETINDEX("CONODNUM")
     DBSETINDEX("CONODFAC")
     DBSETINDEX("CONODART")
     DBSETINDEX("CONODAMF")
  EndiF
     
  DBUSEAREA(.T.,,"FACFILEH",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("FACH_NUM")
     DBSETINDEX("FACH_CLI")
     DBSETINDEX("FACH_FEC")
     DBSETINDEX("FACH_CLF")
     DBSETINDEX("FACH_VEN")
     DBSETINDEX("FACH_FAC")
     DBSETINDEX("FACH_EMP")
     DBSETINDEX("FACH_CIE")
     DBSETINDEX("FACH_NUD")
  ENDIF

  DBUSEAREA(.T.,,"FACFILED",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("FACD_NUM")
     DBSETINDEX("FACD_FAC")
     DBSETINDEX("FACD_ART")
  ENDIF

  DBUSEAREA(.T.,,"FOCFILEH",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("FOCH_NUM")
     DBSETINDEX("FOCH_CLI")
     DBSETINDEX("FOCH_FEC")
     DBSETINDEX("FOCH_CLF")
     DBSETINDEX("FOCH_VEN")
     DBSETINDEX("FOCH_FAC")
     DBSETINDEX("FOCH_EMP")
     DBSETINDEX("FOCH_CIE")
     DBSETINDEX("FOCH_NUD")
  ENDIF

  DBUSEAREA(.T.,,"FOCFILED",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("FOCD_NUM")
     DBSETINDEX("FOCD_FAC")
     DBSETINDEX("FOCD_ART")
  ENDIF

  DBUSEAREA(.T.,,"&RUTAACLI.ClieFile",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("&RutaACli.CLIE_COD")
  ENDIF
     
  DBUSEAREA(.T.,,"&RUTAACOM.PARTIDAS",,.T.,.F.)
  If ErrorArc()
     RETURN
  Else 
     DBSETINDEX("&RutaACom.PART_PAR")
     DBSETINDEX("&RutaACom.PART_ART")
  EndiF  
     
  DBUSEAREA(.T.,,"&RUTAACOM.InvFileh",,.T.,.F.)
  If ErrorArc()
     RETURN
  Else 
     DBSETINDEX("&RutaACom.INVH_COD")
     DBSETINDEX("&RutaACom.INVH_DES")
     DBSETINDEX("&RutaACom.INVH_COE")
     DBSETINDEX("&RutaACom.INVH_DEE")
  EndiF
      
  DBUSEAREA(.T.,,"&RUTAACOM.VenFileh",,.T.,.F.)
  IF ErrorArc()
     RETURN
  ELSE 
     DBSETINDEX("&RutaACom.VENH_COD")
  ENDIF
    
  DBUSEAREA(.T.,,"HISTORIA",,.T.,.F.)
  If ErrorArc()
     DBCloseAll()
     RETURN
  EndiF
   
  DBUSEAREA(.T.,,"NUMERACI",,.T.,.F.)
  If ErrorArc()
     DBCLOSEALL()
     RETURN
  EndiF
   
  DBUSEAREA(.T.,,"CONFIGUR",,.T.,.F.)
  If ErrorArc()
     DBCloseAll()
     RETURN
  EndiF
   
  DBGoTo( 1 ) 
  
  cLetrero:= Letrero
  dFecCie := FecCie
  nCanLin1 := CanLin1
  nCanLin2 := CanLin2
  
  AADD(aDbf, {"Linea",  "N", 04, 0})   
  AADD(aDbf, {"FacRep", "C", 15, 0})
  AADD(aDbf, {"Refere", "C", 30, 0})
  AADD(aDbf, {"FacDes", "C", 40, 0})
  AADD(aDbf, {"FacCan", "N", 12, 2})
  AADD(aDbf, {"CanPen", "N", 12, 2})
  AADD(aDbf, {"CanEnt", "N", 12, 2})
  AADD(aDbf, {"FacPre", "N", 12, 2})
  AADD(aDbf, {"EstArt", "C", 01, 0})
  AADD(aDbf, {"ArtInv", "C", 01, 0})
  AADD(aDbf, {"FacUni", "C", 09, 0})
  AADD(aDbf, {"ValPie", "N", 12, 2})
  AADD(aDbf, {"ArtMad", "C", 01, 0})
  AADD(aDbf, {"Itebis", "C", 01, 0})
  AADD(aDbf, {"DesCue", "C", 01, 0})

  SalvaKey()
   
//SetKey(K_F8 , {|| DC_POPCALC() } )
  SetKey(K_F3,{|| EjecutarTBReporte( 'BU' )  })
  SetKey(K_F12,{|| EjecutarTBReporte( 'GU' )  })
   
  oVentanaDatos                    := CrearVentanaEdicion(ConvToOemCP("CONODESP -> CONOCIMIENTO DE DESPACHO O ENTREGA DE MERCANCIAS"), {0,0},{995,735}  )

  oDA                              := oVentanaDatos:drawingArea
  oVentanaDatos:create()
  oDA:resize    := {|| ResizeToolbarED(oTBar, oDA:currentSize() )}

  DC_CenterObject(oVentanaDatos,SetAppWindow())

  oVentanaDatos:show()

  DC_ClearEvents()
  DC_inkeyRele(0)

  EditToolBarReporte( oVentanaDatos,"BG" )
  ResizeToolbarED(oTBar, oDA:currentSize() )
  oTBar:Show()

  SetAppWindow( appdesktop())
   
  LimpiarVariables()
  
  lDevolver := .f.
  
  GetList := {}
   
  DO WHILE .T.
     
      @ 03,01 DCTABPAGE oTabPage1 SIZE 139,32 CAPTION "CONOCIMIENTO DE DESPACHO"  FONT "10.Tahoma Bold" COLOR {172,200,242}, {175,201,235} PREOFFSET 0 POSTOFFSET 60
      
      DCSETPARENT TO oTabPage1
      
      @ 02,02 DCSAY {|| ConvToOemCP('  Numero De Conocimiento:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 03,02 DCSAY {|| ConvToOemCP('         Tipo De Factura:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 04,02 DCSAY {|| ConvToOemCP('       Numero De Factura:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 05,01 DCSAY {|| REPLICATE(CHR(95),119) } COLOR {101,147,207},XBPSYSCLR_TRANSPARENT
      @ 06,02 DCSAY {|| ConvToOemCP('                   Fecha:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 06,92 DCSAY {|| ConvToOemCP('    Fecha Factura:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 07,02 DCSAY {|| ConvToOemCP('       Empresa o Cliente:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT                                           
      @ 07,92 DCSAY {|| ConvToOemCP('              Ncf:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 08,02 DCSAY {|| ConvToOemCP('      Codigo De Vendedor:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 08,92 DCSAY {|| ConvToOemCP('Dias Transcurrido:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 09,02 DCSAY {|| ConvToOemCP('Precio De Venta / Moneda:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT
      @ 10,02 DCSAY {|| ConvToOemCP('             Observacion:')} COLOR {0,0,0},XBPSYSCLR_TRANSPARENT                                           
      @ 11,01 DCSAY {|| REPLICATE(CHR(95),119) } COLOR {101,147,207},XBPSYSCLR_TRANSPARENT
      
      @ 02,31 DCSAY StrZero(nNumDoc,7,0) SAYFONT "12.Tahoma Bold"
      @ 03,31 DCCOMBOBOX cFactura LIST aFactura TYPE XBPCOMBO_DROPDOWNLIST SIZE 13,08 FONT '9.Courier' ID "INICIO" Valid {|c| ValidarCampo(1,GetList) } When {|| lPrimerCampo }       
      @ 04,31 DCGET nNumFac PICTURE "9999999" POPUP {|c| IIF(Left(cFactura,3) == "Cre",ConsultaFacturasCreditoClientes(@nNumFac),ConsultaFacturasContadoClientes(@nNumFac)) } POPKEY xbeK_F3 POPTOOLTIP "F3 Consultar De Facturas" ;
                    LostFocus {||DC_GetRefresh(GetList)} When {|| lPrimerCampo } Valid {|c| ValidarCampo(2,GetList) }             
      @ 06,31 DCGET dFecDoc PICTURE '@D' When { || lEditar }
      
      @ 06,113 DCGET dFecFac PICTURE '@D' When { || lEditar }
      @ 07,31 DCGET cCodCli PICTURE "@!" When { || lEditar }
      @ 07,45 DCGET cNomCli PICTURE "@!" When { || lEditar }
      @ 07,113 DCGET cNcf  PICTURE '@!' When { || lEditar }
      @ 08,31 DCGET cCodVen PICTURE '@!' When { || lEditar }
      @ 08,45 DCGET cNomVen PICTURE '@!' When { || lEditar }
      @ 08,113 DCGET nDiaTra PICTURE "9,999" When { || lEditar }
      @ 09,31 DCGET cCliPrec PICTURE " 9 " When { || lEditar }
      @ 09,45 DCGET cMoneda When { || lEditar }
      
      @ 10,31 DCGET cComent PICTURE '@!' GETID "FINDIALOGO" When {|| lPrimeraPantalla } LostFocus {||DC_GetRefresh(GetList)} 
      
      DCSETPARENT TO
      
      DC_SETKEYACTIVE(.T.)
      DCGETOPTIONS ;
      SAYFONT '9.Courier' ;
      SAYWIDTH 0  ;
      HILITEGETS GraMakeRGBColor(mcColorCampo) ;
      COLORGETS { { GraMakeRGBColor({0,0,0}), GraMakeRGBColor(aBackColorGet) } } ;
      TABSTOP ;
      NOMAXBUTTON;
      COLOR {214,223,247} ;
      ICON 2002   NOCONFIRM
 
      DCREAD GUI OPTIONS ;
      GetOptions PARENT oVentanaDatos ;
                 SAVE PARENT oVentanaDatos HANDLER ConocimientoDespachoTeclasAplicadas SETFOCUS "INICIO" ;
                 EVAL {|o| DC_GetRefresh(GetList)  }
      
      IF LastKey() == 27 .And. dinultkey == 27 
         EXIT
      ENDIF       

      IF lVolver
         DC_GetDestroy(GetList)
         LimpiarVariables()
         GetList  := {} 
         LOOP
      ENDIF
      
      // Detalles De La Factura
      If Left(cFactura,3) == "Cre"
         DBSelectArea("FACFILED")
         Set Order To 1
         DBSeek(nNumFac)
         Do While !Eof() .And. nNumFac == FacNum
            If EstArt == "D"
               DBSelectArea("FACFILED")
               DBSkip()
               Loop
            EndiF
            cCodArt  := FacRep
            cDesArt  := FacDes
            nCantid  := FacCan
            nPreVen  := FacPre
            nPrecio  := Precio
            nItebiA  := ValItb
            nDescuA  := ValDes
            cItebis  := Itebis
            cDescue  := DesCue
            nCosto   := FacCos
            cRepInv  := FacInv
            nCanPen  := FacCan-CantEnt-CantDv
            nCantVe  := FacCan
            cUnidad  := FacUni
            *
            nSubTot := nSubTot + (FacCan*FacPre)
            nValDes := nValDes + ValDes
            nValItb := nValItb + ValItb
            nTotNet := nSubTot + nValItb - nValDes + nFlete
            nTotFac := nSubTot + nValItb - nValDes + nFlete
            *
            DBSelectArea("INVFILEH")
            Set Order To 1
            DBSeek(cCodArt)
            cRefere := Refere
            cArtMad := ArtMad
            DBSelectArea("cNombreArchivoTemporal")
            Append Blank
            Replace Linea   With RecNo()
            Replace FacRep  With cCodArt
            Replace Refere  With cRefere
            Replace FacDes  With cDesArt
            Replace FacCan  With nCantid
            Replace CanPen  With nCanPen
            Replace FacPre  With nPreVen
            Replace FacUni  With cUnidad
            Replace ArtMad  With cArtMad
            Replace Itebis  With cItebis
            Replace DesCue  With cDesCue
            Replace ArtInv  With cRepInv
            DBSelectArea("FACFILED")
            DBSkip()
         EndDo
      ElseIf Left(cFactura,3) == "Con"
         DBSelectArea("FOCFILED")
         Set Order To 1
         DBSeek(nNumFac)
         Do While !Eof() .And. nNumFac == FacNum
            If EstArt == "D"
               DBSelectArea("FOCFILED")
               DBSkip()
               Loop
            EndiF
            cCodArt  := FacRep
            cDesArt  := FacDes
            nCantid  := FacCan
            nPreVen  := FacPre
            nPrecio  := Precio
            nItebiA  := ValItb
            nDescuA  := ValDes
            cItebis  := Itebis
            cDescue  := DesCue
            nCosto   := FacCos
            cRepInv  := FacInv
            nCanPen  := FacCan-CantEnt-CantDv
            nCantVe  := FacCan
            cUnidad  := FacUni
            *
            nSubTot := nSubTot + (FacCan*FacPre)
            nValDes := nValDes + ValDes
            nValItb := nValItb + ValItb
            nTotNet := nSubTot + nValItb - nValDes + nFlete
            nTotFac := nSubTot + nValItb - nValDes + nFlete
            *
            DBSelectArea("INVFILEH")
            Set Order To 1
            DBSeek(cCodArt)
            cRefere := Refere
            cArtMad := ArtMad
            DBSelectArea("cNombreArchivoTemporal")
            Append Blank
            Replace Linea   With RecNo()
            Replace FacRep  With cCodArt
            Replace Refere  With cRefere
            Replace FacDes  With cDesArt
            Replace FacCan  With nCantid
            Replace CanPen  With nCanPen
            Replace FacPre  With nPreVen
            Replace FacUni  With cUnidad
            Replace ArtMad  With cArtMad
            Replace Itebis  With cItebis
            Replace DesCue  With cDesCue
            Replace ArtInv  With cRepInv
            DBSelectArea("FOCFILED")
            DBSkip()
         EndDo
      ENDIF      
     
      Do While .t.
      
         DC_GetRefresh( GetList )
         GetList := {}

         lPrimerCampo := .f.
         lPrimeraPantalla := .f. 

         DCSETPARENT TO oTabPage1

         @ 26,01 DCSay "REFERENCIA: "
      
         @ 26,112 DCSay " SUBTOTAL: "
         @ 27,112 DCSay "DESCUENTO: "
         @ 28,112 DCSay "    ITBIS: "
         @ 29,112 DCSay "    FLETE: "
         @ 30,112 DCSay "    TOTAL: "
        
         @ 26,15 DCSAY {|| cNombreArchivoTemporal->Refere } COLOR GRA_CLR_BLUE SIZE 40
      
         @ 26,123 DCSAY {|| TransForm(nSubTot,"99,999,999.99") } COLOR GRA_CLR_BLUE SIZE 13 FONT "10.Tahoma Bold" 
         @ 27,123 DCSAY {|| TransForm(nValDes,"99,999,999.99") } COLOR GRA_CLR_BLUE SIZE 13 FONT "10.Tahoma Bold" 
         @ 28,123 DCSAY {|| TransForm(nValItb,"99,999,999.99") } COLOR GRA_CLR_BLUE SIZE 13 FONT "10.Tahoma Bold" 
         @ 29,123 DCSAY {|| TransForm(nFlete,"99,999,999.99") } COLOR GRA_CLR_BLUE SIZE 13 FONT "10.Tahoma Bold" 
         @ 30,123 DCSAY {|| TransForm(nTotNet,"99,999,999.99") } COLOR GRA_CLR_BLUE SIZE 13 FONT "10.Tahoma Bold" 

         DBSelectArea("cNombreArchivoTemporal")
         DBGoTop()

         @ 12,01 DCBROWSE oBrowse PARENT oTabPage1 ;
           SIZE 137,13.5 ;
           FREEZELEFT { 1 } ;
           EDIT xbeBRW_ItemSelected MODE DCGUI_BROWSE_EDITACROSSDOWN ;
           HANDLER ConocimientoDespachoTeclasAplicadas ;
           HEADLINES 2; 
           PRESENTATION aPres COLOR {GRA_CLR_BLACK,GRA_CLR_WHITE} NOSOFTTRACK NOHSCROLL ;
           COLOR GraMakeRGBcolor( { 255, 255, 255 } ) ;
           
           DCBROWSECOL FIELD cNombreArchivoTemporal->FacRep ;
           WIDTH 10 ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Codigo Del Articulo') ;
           HEADER ConvToOemCP("Codigo") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse
         
           DCBROWSECOL FIELD cNombreArchivoTemporal->FacDes ;
           WIDTH 24 ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Descripcion Del Articulo') ;
           HEADER ConvToOemCP("Descrpcion") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse  
           
           DCBROWSECOL FIELD cNombreArchivoTemporal->FacCan ;
           WIDTH 7 ;
           PICTURE "999,999.99" ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Cantidad Vendida') ;
           HEADER ConvToOemCP("Cantidad;Vendida") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse  
         
           DCBROWSECOL FIELD cNombreArchivoTemporal->FacUni ;
           WIDTH 6 ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Unidad') ;
           HEADER ConvToOemCP("Unidad") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse        
           
           DCBROWSECOL FIELD cNombreArchivoTemporal->FacPre ;
           WIDTH 7 ;
           PICTURE "999,999.99" ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Precio De Venta') ;
           HEADER ConvToOemCP("Precio De; Venta") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse    
         
           DCBROWSECOL FIELD cNombreArchivoTemporal->CanPen ;
           WIDTH 7 ;
           PICTURE "999,999.99" ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Cantidad Pendiente') ;
           HEADER ConvToOemCP("Cantidad;Pendiente") ;
           PROTECT {|| .T. } ;
           HCOLOR {34,54,97}, {255,255,151} ;
           PARENT oBrowse  
            
           DCBROWSECOL FIELD cNombreArchivoTemporal->CanEnt ;
           WIDTH 7 ;
           PICTURE "999,999.99" ;
           NORESIZE ;
           MESSAGE ConvToOemCP('Cantidad Entregada') ;
           HEADER ConvToOemCP("Cantidad;Entregada") ;
           PARENT oBrowse ;
           EDITOR 'CANT_ENT' ; 
           ID 'COL_CANT_ENT'
            
           @  NIL, NIL DCGET xNIL PICT '@K 999999.99'  ;
           MESSAGE ConvToOemCP('Ingrese la cantidad a Entregar') ;
           GETID 'CANT_ENT' VALID {|| CantidadEntregada() } LostFocus {||DC_GetRefresh(GetList)} GETOBJECT CANTIDADENTREGADA WHEN {|| cNombreArchivoTemporal->CanPen > 0 }
            
           DC_SETKEYACTIVE(.T.)
           DCGETOPTIONS ;
           SAYFONT '9.Courier' ;
           SAYWIDTH 0  ;
           HILITEGETS GraMakeRGBColor(mcColorCampo) ;
           COLORGETS { { GraMakeRGBColor({0,0,0}), GraMakeRGBColor(aBackColorGet) } } ;
           TABSTOP ;
           NOMAXBUTTON;
           COLOR {214,223,247} ;
           ICON 2002  NOCONFIRM  NOESCAPEKEY

           DCREAD GUI OPTIONS ;
           GetOptions MODAL PARENT oVentanaDatos ;
                      SAVE PARENT oVentanaDatos HANDLER ConocimientoDespachoTeclasAplicadas SETFOCUS "COL_CANT_ENT"
      
           IF LastKey() == 27 .Or. dinultkey == 27
              EXIT 
           ENDIF       

     EndDo

     IF lVolver
        DC_GetDestroy(GetList)
        DC_ClearEvents()
        DCSETPARENT TO
        DC_InkeyRele(0)
        oTabPage1:Destroy() 
        LimpiarVariables()
        GetList := {}
        LOOP
    ENDIF                                                  

   ENDDO  
    
   DC_GetDestroy(GetList)
   DC_ClearEvents()
   DC_InkeyRele(0)
   DBCloseAll()
   BorraFile(AllTrim(cCoUsua)+"ARZ*.DBF")
   BorraFile(AllTrim(cCoUsua)+"ARX*.NTX")

   oVentanaDatos:Destroy()
   RestKey()
   
RETURN   

STATIC PROCEDURE LimpiarVariables()
 
 nNumDoc := 0
 nUltimo := 0
 DBSelectArea("NUMERACI")
 DBGOTO ( 67 )
 nNumDoc := Numero + 1
 IF Numero != 0
    nUltimo := Numero + 1
 ELSE
    nUltimo := 1
 ENDIF   
 
 IF cPreFac == "Cre"
    IF nNivel <= 2
       aFactura := {"Credito","Contado"}
    ELSE     
       aFactura := {"Contado"}
    ENDIF   
 ELSE      
    aFactura := {"Contado","Credito"}
 ENDIF   
 
 cFactura:= aFactura[1]
 nNumFac := 0
 dFecDoc := dFecha
 dFecFac := Ctod("  /  /    ")
 cNcf    := Space(19)
 cCliPrec:= Space(3)
 nDiaTra := 0
 cMoneda := Space(3)
 cEstado := Space(1)
 cCodCli := Space(8)
 cNomCli := Space(30)
 cDirCli := Space(40)
 cCiuCli := Space(15)
 cCodVen := Space(2)
 cNomVen := Space(30)
 cNumRef := Space(8)
 nValDoc := 0
 cComent := Space(50)
 cTelCli := Space(20)
 cCodBan := Space(2)
 cNumChq := Space(10)
 cNumTcr := Space(20)
 nTotNet := 0
 nTotCono:= 0
 nSubTot := 0
 nValDes := 0
 nValItb := 0
 nFlete  := 0
 lProcesa:= .f.
 lEditar := .f.
 lVolver := .f.
 lPrimerCampo:= .t.
 lPrimeraPantalla := .t.
 
 If Select("cNombreArchivoTemporal") != 0       
    DBSelectArea("cNombreArchivoTemporal")
    DBCloseArea()      
    BorraFile(AllTrim(cCoUsua)+"ARZ*.DBF")
    BorraFile(AllTrim(cCoUsua)+"ARX*.NTX")
 EndiF 
 
 cNombreArchivoTemporal:= AllTrim(cCoUsua)+'ARZ'+SubStr(StrTran(Time(),":",""),3,3)
 cNombreOrden1         := AllTrim(cCoUsua)+'ARX'+SubStr(StrTran(Time(),":",""),3,3)
      
 DBCREATE(cNombreArchivoTemporal, aDbf)
 DBSelectArea(0)
 USE &cNombreArchivoTemporal ALIAS cNombreArchivoTemporal EXCLUSIVE    
 
RETURN

STATIC PROCEDURE EjecutarTBReporte( cKey )
  LOCAL aGet :=  DC_GetActiveInfo()
  DO CASE
     CASE cKey = 'SA'
         If lPrimerCampo
            KEYBOARD Chr(K_ESC)
         ELSE
            If lPrimeraPantalla 
             lPrimerCampo:= .t.
             lVolver     := .t.
             DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)
            Else
             Opcr := ConfirmBox(,"DESEA SALIR SIN PROCESAR CONOCIMIENTO DE DESPACHO222",;
                                 "** SALIR DEL CONOCIMIENTO DE DESPACHO **",;
                                  XBPMB_YESNO , ;
                                  XBPMB_QUESTION+XBPMB_APPMODAL+XBPMB_MOVEABLE,XBPMB_DEFBUTTON1 )
                      
                 IF Opcr == XBPMB_RET_YES
                    lVolver     := .t.
                    DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)
                 ENDIF
            EndiF
         ENDIF   
     CASE cKey = 'BU'
         PostAppEvent( xbeP_Keyboard,xbeK_F3,,aGet[4] )
     CASE cKey = 'GU'   
         Totales()
         IF lProcesa .And. !lPrimerCampo .And. nTotCono != 0
            ProcesarConocimiento()
            lVolver := .t.
            DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)
         ELSE
            DC_WinAlert("IMPOSIBLE PROCESAR O GUARDAR"+Chr(10)+"INFORMACION INCOMPLETA"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
            BorraBlanco()
            DBSelectArea("cNombreArchivoTemporal")
            DBGoTop()
            oBrowse:refreshAll()
            DC_GetRefresh(GetList)
         ENDIF   
     OTHERWISE
  ENDCASE
RETURN

STATIC PROCEDURE EditToolBarReporte( oDlgFW, cBarra )
LOCAL oDA

    oDA               := oDlgFW:drawingArea
    oTBar             := CrearToobarVentanaEdicion( oDA )
  //oTbar:textAlign   := XBPALIGN_RIGHT
    
    **Salir
    oBotton := oTBar:addItem("ESC RETORNAR", 130,,130,,,'SA')
    oBotton:tooltipText = ConvToOemCP("Retornar Al Menu")
    oTBar:addItem( ,,,,,XBPTOOLBAR_BUTTON_SEPARATOR,'BSEP0')
    oTBar:transparentColor := GRA_CLR_INVALID
    oTBar:buttonClick := {|oButton| EjecutarTBReporte( oButton:key ) }
    oTBar:setColorBG( GraMakeRGBColor( {175,201,235} ) )
    
    IF "B" $ cBarra // Consultar
       oBotton :=oTBar:addItem("F3 CONSULTAR", 134,,134,,,'BU')
       oBotton:tooltipText = ConvToOemCP("Consulta Del Campo Correspondiente")
       oTBar:addItem( ,,,,,XBPTOOLBAR_BUTTON_SEPARATOR,'BSEP1')
    ENDIF
    
    IF "G" $ cBarra // Guardar Informacion
      oBotton :=oTBar:addItem("F12 PROCESAR", 405,,405,,,'GU')
      oBotton:tooltipText = ConvToOemCP("Procesar o Guardar Informacion En Pantalla")
    ENDIF
    
RETURN

STATIC PROCEDURE ImprimirDocumento()
 
 If !InicializarPrinter() 
    Return 
 EndiF
 
 PonerMsj( {" Impresin De Conocimiento"} )
 
 mcQuien := AllTrim(cCoUsua)+".Prn"
 SET PRINTER TO "&mcQuien"
 
 SET PRINTER oN
 SET DEVICE TO PRINTER
 SET CONSOLE oFF
 
 DBSelectArea("cNombreArchivoTemporal")
 BorraBlanco()
 If mcPapDev == "2" 
    rLinea := nCanLin1
    cForma := "G"
 ElseIf mcPapDev == "1" 
    @ PRow(),00 Say CHR(27)+"C"+CHR(33)
    rLinea := nCanLin2
    cForma := "M"
 ElseIf mcPapDev == "4" 
    @ PRow(),00 Say CHR(27)+"C"+CHR(33)
    rLinea := 7
    cForma := "P" 
 ElseIf mcPapDev == "3" 
    rLinea := Reccount()
    cForma := "R"
 EndiF
 
 nPag := 0
 
 DBSelectArea("cNombreArchivoTemporal")
 DBGoTop()
 DO WHILE !Eof()
   EncabezF()
   FOR nContador = 1 TO rLinea
       If !Eof()
          cCodArt := FacRep
          cDesArt := FacDes
          nCantid := FacCan
          nFacPre := FacPre
          aItebis := Itebis
          aDesCue := DesCue
          cRepUn1 := FacUni
          cArtMad := ArtMad
          nValPie := ValPie
          nCanEnt := CanEnt
          If cForma == "G" .Or. cForma == "M"
             @ PRow()+01,00 Say Chr(15)+cCodArt+Space(2)+IIF(aItebis=="N","E ",Space(2))+IIF(aDesCue=="N","*",Space(1))+Space(2)+IIF(cArtMad!="S",cDesArt,Left(cDesArt,15)+Space(1)+TransForm(nValPie,"99,999.99")+" PIES")+Space(2)+IIF(nCantid!=0,TransForm(nCantid,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))+Space(2)+IIF(nCanEnt!=0,TransForm(nCanEnt,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))+Chr(18)
          ElseIf cForma == "R"
             @ PRow()+01,00 Say cCodArt+Space(1)+IIF(aItebis=="N","E ",Space(2))+IIF(aDesCue=="N","*",Space(1))+Space(1)+IIF(cArtMad!="S",cDesArt,Left(cDesArt,15)+Space(1)+TransForm(nValPie,"99,999.99")+" PIES")
             @ PRow()+01,00 Say IIF(nCantid!=0,TransForm(nCantid,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))
             @ PRow()+01,00 Say IIF(nCanEnt!=0,TransForm(nCanEnt,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))
          ElseIf cForma == "P"
             @ PRow()+01,00 Say Chr(15)+cCodArt+Space(1)+IIF(aItebis=="N","E ",Space(2))+IIF(aDesCue=="N","*",Space(1))+Space(1)+IIF(cArtMad!="S",cDesArt,Left(cDesArt,15)+Space(1)+TransForm(nValPie,"99,999.99")+" PIES")+Chr(18)
             @ PRow()+01,00 Say Chr(15)+IIF(nCantid!=0,TransForm(nCantid,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))+Chr(18)
             @ PRow()+01,00 Say Chr(15)+IIF(nCanEnt!=0,TransForm(nCanEnt,cCanSal),Space(Len(cCanSal)))+Space(9-Len(cCanSal))+Space(2)+IIF(cImpUni=="S",cRepUn1,Space(9))+Chr(18)
          EndiF   
          DBSkip()
       Else
          If cForma != "R"
             @ PRow()+01,00 Say Space(1)
          EndiF   
       Endif
   Next
   If cForma == "G" .Or. cForma == "M"
      @ PRow(),00 Say Replicate("_",80)
   Else
      @ PRow()+01,00 Say Replicate("-",40)
   EndiF   
   If Eof()
      @ PRow()+03,00 Say "---------------------       -----------------------"
      @ PRow()+01,00 Say "RECIBIDO POR (Nombre)       ENTREGADO POR          "            
      If cForma == "G" .Or. cForma == "M"
         If cEstado == "C"
            @ PRow()+01,00 Say PADC(AllTrim("*** CONOCIMIENTO DE DESPACHO CANCELADO ***"),80," ")
         EndiF
         @ PROw()+01,00 Say Chr(27)+Chr(69)+PADC(AllTrim(cUsuario)+"-"+AllTrim(PresHora(Time())),80," ")+Chr(27)+Chr(70)
         Eject
         Exit
      ElseIf cForma == "R" .Or. cForma == "P"
         If cEstado == "C"
            @ PRow()+01,00 Say PADC(AllTrim("*** CONOCIMIENTO DE DESPACHO CANCELADO ***"),40," ")
         EndiF   
         @ PROw()+01,00 Say Chr(27)+Chr(69)+PADC(AllTrim(cUsuario)+"-"+AllTrim(PresHora(Time())),40," ")+Chr(27)+Chr(70)
         If cForma == "R"
            @ PRow()+mnLineaAvanzar,00 Say Chr(0)
         EndiF   
         IF mcCortePapel == "S"
            IF mcCorteTotal == "1"
               SET CONSOLE oFF
               SET PRINTER oN
               ?? Chr(27)+Chr(105)
               SET PRINTER oFF
               SET PRINTER TO
            ELSEIF mcCorteTotal == "2"
               SET CONSOLE oFF
               SET PRINTER oN
               ?? Chr(27)+Chr(104)
               SET PRINTER oFF
               SET PRINTER TO
            ENDIF
         ENDIF
         Exit
      EndiF   
   EndiF      
   If cForma != "R"
      Eject
   EndiF
 EndDo
 
 If cForma != "R"
    @ PRow(),00 Say Chr(18)+Chr(27)+"C"+Chr(66) 
 EndiF
 EndPrnRep()
 QuitarMsj()
 
Return

// Encabezado De La Impresion De Factura
Static Procedure EncabezF()
   nPag := nPag + 1
   If cForma == "G" .Or. cForma == "M"
      If mcImpEnc3 == "S"
         Letreros(1)
      EndiF   
      @ PRow()+01,70 Say "PAG: "+AllTrim(Str(nPag,3,0))
      @ PRow(),00    Say Chr(27)+Chr(69)+Chr(14)+PADC(AllTrim("CONOCIMIENTO DE DESPACHO"),40)+Chr(27)+Chr(70)+Chr(18)+Chr(20)
      @ PRow(),00    Say Replicate("_",80)
      @ PRow()+01,00 Say "      Cliente: "+Chr(27)+Chr(69)+IIF(cImpCod=="S",cCodCli,"")+Space(1)+cNomCli+Chr(27)+Chr(70)
      @ PRow(),59    Say Chr(27)+Chr(69)+"#Conocimiento: "+StrZero(nNumDoc,7,0)+"r"+Chr(27)+Chr(70)
      @ PRow()+01,00 Say "    Direccion: "+AllTrim(cDirCli)
      @ PRow(),66    Say Chr(15)+"Fec.: "+Chr(18)+Dtoc(dFecDoc)
      @ PRow()+01,00 Say "       Ciudad: "+Chr(27)+Chr(69)+cCiuCli+Chr(27)+Chr(70)
      @ PRow()+01,00 Say " Telefono-Fax: "+cTelCli+" "+IIF(Empty(cCodCli),ClieFile->CliTel2,Space(8))+IIF(cFacTip=="C",IIF(!Empty(ClieFile->CliFax),"  Fax: "+ClieFile->CliFax,Space(15)),Space(15))
      @ PRow()+01,00 Say " Num. Factura: "+StrZero(nNumFac,7,0)+Space(1)+IIF(cFacTip=="C","CREDITO","CONTADO")
      @ PRow()+01,00 Say "  Observacion: "+Chr(27)+Chr(69)+cComent+Chr(27)+Chr(70)
      If !Empty(cCodVen)
         @ PRow(),57 Say "Codigo Vendedor: "+cCodVen+" "+SubStr(VenFileh->VenNom,1,1)+SubStr(VenFileh->VenNom,AT(" ",VenFileh->VenNom)+1,1)   
      EndiF
      @ PRow()+01,00 Say PADC(AllTrim("Hacemos constar haber recibido la mercancia detallatada a continuacin"),80," ")
      @ PRow(),00 Say Replicate("_",80)
      @ PRow()+01,00 Say Chr(15)+Chr(27)+Chr(71)+"REFERENCIA            DESCRIPCION                               CANTID FAC             CANTID ENT           "+Chr(27)+Chr(72)+Chr(18)
      @ PRow(),00 Say Replicate("_",80)
   Else
      If mcImpEnc3 == "S"
         Letreros(2)
      EndiF   
      @ PRow()+01,00 Say Chr(27)+Chr(69)+PADC(AllTrim("CONOCIMIENTO DE DESPACHO"),40)+Chr(27)+Chr(70)
      @ PRow()+01,00 Say Replicate("-",40)
      @ PRow()+01,00 Say Chr(27)+Chr(69)+"#Conoc..: "+StrZero(nNumDoc,7,0)+"r"+Chr(27)+Chr(70)
      @ PRow(),25    Say "Fecha: "+Dtoc(dFecDoc)
      If !Empty(cNomCli)
         @ PRow()+01,00 Say " Cliente: "+Chr(27)+Chr(69)+cNomCli+Chr(27)+Chr(70)
      EndiF
      If !Empty(cDirCli)   
         @ PRow()+01,00 Say " Direcc.: "+Left(cDirCli,20)
      EndiF   
      If !Empty(SubStr(cDirCli,21))
         @ PRow()+01,00 Say SubStr(cDirCli,21,30)
      EndiF
      If !Empty(cCiuCli)
         @ PRow()+01,00 Say "  Ciudad: "+Chr(27)+Chr(69)+cCiuCli+Chr(27)+Chr(70)
      EndiF
      If !Empty(cTelCli)   
        @ PRow()+01,00  Say "Telefono: "+cTelCli
      EndiF   
      @ PRow()+01,00 Say "#Factura: "+StrZero(nNumFac,7,0)+Space(1)+IIF(cFacTip=="C","CREDITO","CONTADO")
      If !Empty(cComent)
         @ PRow()+01,00 Say "  Obser.: "+Chr(27)+Chr(69)+cComent+Chr(27)+Chr(70)
      EndiF   
      If !Empty(cCodVen)
         @ PROw()+01,00 Say "Vendedor: "+cCodVen+" "+IIF(mcImprNomVen=="S",VenFileh->VenNom," ")
      EndiF
      @ PRow()+01,00 Say PADC(AllTrim("Hacemos constar haber recibido la mercancia detallatada a continuacin"),40," ")
      @ PRow()+01,00 Say Replicate("-",40)
   EndiF

Return

// Teclas Aplicadas
STATIC FUNCTION ConocimientoDespachoTeclasAplicadas( nEvent, mp1, mp2, oXbp, oDlgopci, aGetlist, aRef, lOk )
 LOCAL i, nkey
 LOCAL ciclogui := DCGUI_NONE
 LOCAL Getlist

 dinultkey := 0

 IF nEvent = xbeP_Keyboard

    dinultkey    := 0
    nkey         := mp1

    IF mp1 <> K_ESC
       dinultkey :=   DC_KEYTRAN(mp1, 1)
      
     //IF ( dinultkey = 13 .AND. dc_getobjectid(oXbp,GetList) == "FINDIALOGO" ) .OR. dinultkey = 3
       IF ( dinultkey = 13 .AND. dc_getobjectid(oXbp,GetList) == "FINDIALOGO" ) 
          dinultkey := 13
          ciclogui  := DCGUI_EXIT_OK
       ENDIF
       
    ELSEIF mp1 = K_ESC .And. lPrimerCampo
       dinultkey := 27
       ciclogui  := DCGUI_EXIT_OK
    ELSE
       lPrimerCampo:= .t.  
       lVolver     := .t.
       Opcr := ConfirmBox(,"DESEA SALIR SIN PROCESAR CONOCIMIENTO DE DESPACHO",;
                           "** SALIR DEL CONOCIMIENTO DE DESPACHO **",;
                               XBPMB_YESNO , ;
                               XBPMB_QUESTION+XBPMB_APPMODAL+XBPMB_MOVEABLE,XBPMB_DEFBUTTON1 )
                      
               IF Opcr == XBPMB_RET_YES
                  dinultkey := 13
                  ciclogui  := DCGUI_EXIT_OK
               ENDIF
    ENDIF

    dinultkey := IF(empty(dinultkey), 13, dinultkey)

    KEYBOARD CHR(dinultkey)
    INKEY(0)
    
 ELSEIF nEvent = xbeP_Close 
  dinultkey:= 27
  ciclogui := DCGUI_EXIT_OK
 ENDIF

 IF (dinultkey = 27 .OR. NEVENT = 27 .OR. LASTKEY() = 27) .AND. nEvent <> xbeP_Close 
    DC_getDestroy(GetList)
    dinultkey:= 27
    ciclogui := DCGUI_EXIT_OK
 ENDIF

RETURN ciclogui

// Borra Lineas En Blanco 
Static Procedure BorraBlanco()
   DBSelectArea("cNombreArchivoTemporal")
   DBGoTop()
   Do While !Eof()
      If Empty(FacRep) .And. Empty(FacDes)
         RLock()
         DBDelete()
         DBUnLock()
      EndiF   
      DBSelectArea("cNombreArchivoTemporal")
      DBSkip()
   EndDo
Return

STATIC FUNCTION ValidarCampo(oCaso,GetList)
   LOCAL lRetVal := .t.
   DO CASE
      CASE oCaso == 1 
           If Left(cFactura,3) == "Cre"
              DBSelectArea("NUMERACI")
              DBGOTO ( 1 )
              nNumFac := Numero 
           ElseIf Left(cFactura,3) == "Con"
              DBSelectArea("NUMERACI")
              DBGOTO ( 2 )
              nNumFac := Numero 
           EndiF
           @ 04,31 DCSay StrZero(nNumFac,7,0) PICTURE "9999999"
           DC_GetRefresh( GetList )
      CASE oCaso == 2 
           IF nNumFac <= 0
              DC_WinAlert("NUMERO DE FACTURA INVALIDO"+Chr(10)+"ESTE PUEDE SER IGUAL O MENOR QUE CERO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
              DC_ReadGuiLastKey( GetList )
              DC_GetRefresh( GetList )
              lProcesa:= .f.
              Return .f.
           ELSE
              IF Left(cFactura,3) == "Cre"
                 DBSelectArea("FACFILEH")
                 Set Order To 1
                 If DBSeek(nNumFac)
                    If Estado == "C"
                       DC_WinAlert("IMPOSIBLE REALIZAR ALGUNA TRANSACCION"+Chr(10)+"FACTURA ESTA CANCELADA"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                       DC_ReadGuiLastKey( GetList )
                       DC_GetRefresh( GetList )
                       lProcesa:= .f.
                       Return .f.    
                    Endif
                    nDiaTra := dFecha-FacFec
                    dFecFac := FacFec
                    IF !Empty(Ncf)
                       cNcfm   := Ncf+StrZero(NumNcf,8,0)
                    ENDIF   
                    cCodCli := FacCli
                    cCodVen := FacVnt
                    cMoneda := IIF(Moneda!="U","rd$","us$")
                    nFlete  := FacFle
                    lExiste := .t.
                    cEstado := Estado
                    cTipoItebis:= TipoItb
                    cActInv := IIF(ActInv=="N",ActInv,"S")
                    nPorItb := FacItb
                    nPorDes := FacDto
                    nDiaCre := FacCon
                    cCajaFactura:= Caja
                    If FacPre == "1" .Or. FacPre == " "
                       cCliPrec:= " 1 "
                    ElseIf FacPre == "2"
                       cCliPrec:= " 2 "
                    ElseIf FacPre == "3"
                       cCliPrec:= " 3 "   
                    ElseIf FacPre == "4"
                       cCliPrec:= " 4 "
                    EndiF   
                    DBSelectArea("CLIEFILE")
                    Set Order To 1
                    DBSeek(cCodCli)
                    cNomCli := CliEmp
                    DBSelectArea("VENFILEH")
                    Set Order To 1
                    DBSeek(cCodVen)
                    cNomVen := VenNom
                    @ 06,113 DCSay dFecFac PICTURE "@D"
                    @ 07,31  DCSay cCodCli PICTURE "@!"
                    @ 07,45  DCSay cNomCli PICTURE "@!"
                    IF !Empty(cNcf)
                       @ 07,113 DCSay cNcf   PICTURE "@!"
                    ENDIF   
                    @ 08,31 DCSay cCodVen  PICTURE "@!"
                    @ 08,45 DCSay cNomVen  PICTURE "@!"
                    @ 08,113 DCSay nDiaTra PICTURE "9,999"
                    @ 09,31  DCSay cCliPrec 
                    @ 09,45  DCSay cMoneda
                    lPrimerCampo := .f.
                 Else
                    DC_WinAlert("NUMERO DE FACTURA"+Chr(10)+"NO EXISTE EN ARCHIVO MAESTRO DE FACTURAS A CREDITO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                    DC_ReadGuiLastKey( GetList )
                    DC_GetRefresh( GetList )
                    lProcesa:= .f.
                    Return .f. 
                 EndiF
              ELSEIF Left(cFactura,3) == "Con"
                 DBSelectArea("FOCFILEH")
                 Set Order To 1
                 If DBSeek(nNumFac)
                    If Estado == "C"
                       DC_WinAlert("IMPOSIBLE REALIZAR ALGUNA TRANSACCION"+Chr(10)+"FACTURA ESTA CANCELADA"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                       DC_ReadGuiLastKey( GetList )
                       DC_GetRefresh( GetList )
                       lProcesa:= .f.
                       Return .f.    
                    Endif
                    nDiaTra := dFecha-FaFec
                    dFecFac := FaFec
                    IF !Empty(cNcf)
                       cNcf   := Ncf+StrZero(NumNcf,8,0)
                    ENDIF
                    cCodCli := FaCli
                    cCodVen := FaVnt
                    nPorItb := FaItb
                    nPorDes := FaDto
                    nValTar := Tarjet
                    cEstado := Estado
                    nEfecti := Efecti
                    nCheque := Cheque
                    nTarjet := Tarjet
                    cTipoItebis:= TipoItb
                    cDirCli := FaDir
                    cCiuCli := Left(FaCiu,14)
                    cTelCli := FaTel
                    lExiste := .t.
                    cCajaFactura:= Caja
                    cMoneda := IIF(Moneda!="U","rd$","us$")
                    nFlete  := FaFle
                    cActInv := IIF(ActInv=="N",ActInv,"S")
                    If FacPre == "1" .Or. FacPre == " "
                       cCliPrec:= " 1 "
                    ElseIf FacPre == "2"
                       cCliPrec:= " 2 "
                    ElseIf FacPre == "3"
                       cCliPrec:= " 3 "   
                    ElseIf FacPre == "4"
                       cCliPrec:= " 4 "
                    EndiF   
                    IF !Empty(cCodCli)
                       DBSelectArea("CLIEFILE")
                       Set Order To 1
                       DBSeek(cCodCli)
                       cNomCli := CliEmp
                    ELSE
                       cNomCli := FocFileh->FaEmp
                    ENDIF
                    DBSelectArea("VENFILEH")
                    Set Order To 1
                    DBSeek(cCodVen)
                    cNomVen := VenNom
                    @ 06,113 DCSay dFecFac PICTURE "@D"
                    @ 07,31  DCSay cCodCli PICTURE "@!"
                    @ 07,45  DCSay cNomCli PICTURE "@!"
                    IF !Empty(cNcf)
                       @ 07,113 DCSay cNcf   PICTURE "@!"
                    ENDIF   
                    @ 08,31 DCSay cCodVen PICTURE "@!"
                    @ 08,45 DCSay cNomVen PICTURE "@!"
                    @ 08,113 DCSay nDiaTra PICTURE "9,999"
                    @ 09,31  DCSay cCliPrec 
                    @ 09,45  DCSay cMoneda
                    lPrimerCampo := .f.
                 Else
                    DC_WinAlert("NUMERO DE FACTURA"+Chr(10)+"NO EXISTE EN ARCHIVO MAESTRO DE FACTURAS AL CONTADO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                    DC_ReadGuiLastKey( GetList )
                    DC_GetRefresh( GetList )
                    lProcesa:= .f.
                    Return .f.    
                 EndiF
              ENDIF   
           ENDIF   
      CASE oCaso == 3 
           IF Empty(StrTran(Dtoc(dFecDoc),"/","")) 
              DC_WinAlert("FECHA INVALIDA"+Chr(10)+"ESTA NO PUEDE ESTAR EN BLANCO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
              DC_ReadGuiLastKey( GetList )
              DC_GetRefresh( GetList )
              lProcesa:= .f.
              Return .f.
           ELSE    
              IF dFecDoc > dFecha
                 DC_WinAlert("FECHA INVALIDA"+Chr(10)+"ESTA NO PUEDE SER MAYOR QUE LA FECHA ACTUAL"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                 DC_ReadGuiLastKey( GetList )
                 DC_GetRefresh( GetList )
                 lProcesa:= .f.
                 Return .f.
              ELSEIF dFecDoc < dFecControl
                 DC_WinAlert("FECHA INVALIDA"+Chr(10)+"ESTA NO PUEDE SER MENO QUE LA FECHA CONTROL"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
                 DC_ReadGuiLastKey( GetList )
                 DC_GetRefresh( GetList )
                 lProcesa:= .f.
                 Return .f.
              ENDIF
           ENDIF        
      CASE oCaso == 10
           IF cNombreArchivoTemporal->CanEnt < 0
              DC_WinAlert("CANTIDAD A ENTREGAR"+Chr(10)+"NO PUEDE SER MENOR QUE CERO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
              lProcesa := .f.
              Return .f.
           ELSEIF cNombreArchivoTemporal->CanEnt > cNombreArchivoTemporal->CanPen
              DC_WinAlert("CANTIDAD A ENTREGAR"+Chr(10)+"NO PUEDE SER MAYOR QUE LA CANTIDAD PENDIENTE"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
              lProcesa := .f.
              Return .f.
           ELSE
              lProcesa := .t.   
           ENDIF
   ENDCASE
RETURN lRetVal

STATIC FUNC CantidadEntregada()
 LOCAL lRetorna := .T.
 LOCAL nRegistro
 DBSelectArea("cNombreArchivoTemporal")
 nRegistro := RecNo()
 IF cNombreArchivoTemporal->CanEnt < 0
    DC_WinAlert("CANTIDAD A ENTREGAR"+Chr(10)+"NO PUEDE SER MENOR QUE CERO"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
    cNombreArchivoTemporal->CanEnt := 0
    DC_ReadGuiLastKey( GetList )
    DC_GetRefresh( GetList )
    lProcesa := .f.
    Return .f.
 ELSEIF cNombreArchivoTemporal->CanEnt > cNombreArchivoTemporal->CanPen
    DC_WinAlert("CANTIDAD A ENTREGAR"+Chr(10)+"NO PUEDE SER MAYOR QUE LA CANTIDAD PENDIENTE"+Chr(10)+"... PULSE ENTER, ESC O CLICK [Ok] PARA CONTINUAR ...")
    cNombreArchivoTemporal->CanEnt := 0
    DC_ReadGuiLastKey( GetList )
    DC_GetRefresh( GetList )
    lProcesa := .f.
    Return .f.
 ELSE
    lProcesa := .t.   
 ENDIF
 DBSelectArea("cNombreArchivoTemporal")
 Go nRegistro
RETURN lRetorna

// Proceso Conocimiento
Static Procedure ProcesarConocimiento()
 
 PonerMsj( {"Proceso De Conocimiento En Ejecucin"} )
 
 DBSelectArea("NUMERACI")
 DBGoTo ( 67 )
 While !RLock(); EndDo
 nNumDoc := Numero + 1
 Replace Numero With nNumDoc
 DBCommit()
 DBUnLock()
 Historia(cUsuario,dFecha,Val( StrTran(Left(Time(),5),":", "")),StrZero(nNumDoc,10,0),"","Creo Conocimiento De Despacho") 
 DBSelectArea("CONOH")
 While !RLock(); EndDo
 DBAppend()
 Replace FacNum  With nNumDoc
 Replace NumFac  With nNumFac
 Replace FacTot  With nSubTot
 Replace FacCli  With cCodCli
 Replace FacTip  With IIF(Left(cFactura,3)=="Cre","C","O")
 Replace FacFec  With dFecDoc
 Replace FacCli2 With cNomCli
 Replace FacPre  With Left(AllTrim(cCliPrec),1)
 Replace ActInv  With Left(cRepInv,1)
 Replace Moneda  With Upper(Left(cMoneda,1))
 Replace PorItb  With nPorItb
 Replace PorDes  With nPorDes
 Replace FacNet  With nTotNet
 Replace Caja    With cCajaFactura
 Replace CodVen  With cCodVen
 Replace FacDes  With nValDes
 Replace FacItb  With nValItb
 Replace TipoItb With cTipoItebis
 Replace FacObs  With cComent
 Replace Usuario With cUsuario
 DBCommit()
 DBUnLock()
 DBSelectArea("cNombreArchivoTemporal")
 DBGoTop()
 Do While !Eof()
     cCodArt := FacRep
     cDesArt := FacDes
     nCantid := FacCan
     nPrecio := FacPre
     nPreVen := FacPre
     cRepInv := ArtInv
     aItebis := Itebis
     aDesCue := DesCue
     cRepUn1 := FacUni
     nCanEnt := CanEnt
     If nCanEnt != 0
        DBSelectArea("CONOD")
        While !RLock(); EndDo
        DBAppend()
        Replace FacNum  With nNumDoc
        Replace FacFec  With dFecDoc
        Replace FacRep  With cCodArt
        Replace FacCan  With nCanEnt
        Replace Cantid  With nCantid
        Replace FacPre  With nPreVen
        Replace Precio  With nPrecio
        Replace Itebis  With aItebis
        Replace DesCue  With aDesCue
        Replace ArtInv  With cRepInv
        Replace FacDes  With cDesArt
        Replace FacUni  With cRepUn1
        Replace CantEnt With nCanEnt
        DBCommit()
        DBUnLock()
        If Left(cFactura,3) == "Cre"
           DBSelectArea("FACFILED")
           Set Order To 2
           DBSeek(StrZero(nNumFac,7,0)+cCodArt)
           While !RLock(); EndDo
           If Left(cRepInv,1) == "S"
              Replace CantEnt With (CantEnt+nCanEnt)
           EndiF   
           If FacCan == CantEnt
              Replace EstArt With "E"
           EndiF
           DBCommit()
           DBUnLock()
        ElseIf Left(cFactura,3) == "Con"
           DBSelectArea("FOCFILED")
           Set Order To 2
           DBSeek(StrZero(nNumFac,7,0)+cCodArt)
           While !RLock(); EndDo
           If Left(cRepInv,1) == "S"
              Replace CantEnt With (CantEnt+nCanEnt)
           EndiF   
           If FacCan == CantEnt
              Replace EstArt With "E"
           EndiF
           DBCommit()
           DBUnLock()
        EndiF
     EndiF
     DBSelectArea("cNombreArchivoTemporal")
     DBSkip()
 EndDo
 QuitarMsj()
 Opcr := ConfirmBox(,"DESEA IMPRIMIR CONOCIMIENTO DE DESPACHO",;
                    "** IMPRESION DE CONOCIMIENTO DE DESPACHO **",;
                     XBPMB_YESNO , ;
                     XBPMB_QUESTION+XBPMB_APPMODAL+XBPMB_MOVEABLE,XBPMB_DEFBUTTON1 )
                     
      IF Opcr != XBPMB_RET_YES
         RETURN
      ELSE
         ImprimirDocumento()
      EndiF  
 
Return

// Totales
Static Procedure Totales()
  nTotCono := 0
  DBSelectArea("cNombreArchivoTemporal")
  DBGoTop()
  Do While !Eof()
     IF cNombreArchivoTemporal->CanEnt > 0 
        nTotCono := nTotCono + 1 
     ENDIF   
     DBSelectArea("cNombreArchivoTemporal")
     DBSkip()
  EndDo
Return


